# DualTFR_st
###This is the spatio-temporal version of baseline tracker DualTFR
### DualTFR: Dual-branch Transformer Tracker with No Convolutional Neural Networks

###Description:
In the baseline tracker DualTFR, we further add context information
of searching area to the template transformer branch. In every frame, 
the feature of search area will go through global average pooling layer and 
be concated to the template features. The model is re-trained with dynamic
context information setttings.

DualTFR:
Inspired by the rapid development of vision transformers, we use pure transformer components to formulate our tracker without convolutional 
networks. No CNN backbone is used to extract feature embeddings like other transformer tracker. We use the half stage of the block 3 from Swin transformer 
as the feature extractor which uses linear projection for image. The feature extractor is pretrained in Imagenet10K. A Siamese correlation sturcture is 
adopted. The template feature and search feature are further processed by CrossVit-like network for feature fusion. 
We removed the class token in CrossVit and only use tokens generated from each image patch to better handle visual tracking problem. 
The CrossVit-like network is not pretrained. Futher, a multi-layer perception layer is used for regression and classification like TransT style. 
We furthur use AlphaRefine to generate mask.


Please Note that the name of our model in this code may changed to 
TrackingNc, transcross or crossVit,  they are the same with the name DualTFR

[Model weight](https://github.com/phiphiphi31/DMB) can be download from 
https://github.com/phiphiphi31/DMB
* One is model weight for DualTFR_st
* another is for Alpha-refine 

###Please specify the two model path and one json path in
* Make sure the correctness of path, absolute path is preferred.
   ```bash
   ./pysot_toolkit/trackers/tracker_ar_sz_hp.py
   pth_path = 'model path - CrossViT_ep0099.pth.tar'
   hp_path = 'hp_rand.json path, in the first level of this project'
   alpha_refine_path = 'alpha-refine model path'
   ```
### trackers.ini file is:
* It also can be find in the first level of this project
    ```bash
    [DualTFR]  # <tracker-name>
    label = DualTFR
    protocol = traxpython
    command = import pysot_toolkit.trackers.tracker_ar_sz_hp as run_vot;
              run_vot.run_vot_exp()
    paths = /tmp/code
    ```

## Reproduce
* we run our test in docker environment which is easy to reproduce:
    ```bash
    Our image can be downloaded from:
    jaffe03/vot21new:latest
    ```
Or you can install the dependencies by yourself.

#### Install dependencies
* Our environment
    ```bash
    Tesla V100, 32G
    cuda 10.1
    pytorch pytorch=1.5 torchvision=0.6.1
    ```

* Install  packages
    ```bash
    conda install -c pytorch pytorch=1.5 torchvision=0.6.1 cudatoolkit=10.1
    conda install matplotlib pandas tqdm
    pip install opencv-python tb-nightly visdom scikit-image tikzplotlib gdown
    conda install cython scipy
    sudo apt-get install libturbojpeg
    pip install pycocotools jpeg4py
    pip install wget yacs
    pip install shapely==1.6.4.post2
    
  
## Acknowledgement
Thanks the  python framework [PyTracking](https://github.com/visionml/pytracking), [PySOT](https://github.com/STVIR/pysot) 
 and  the vision transformer project [ViT](https://github.com/lucidrains/vit-pytorch)
## Contact
* Fei Xie (email:jaffe03@seu.edu.cn)
